﻿//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  Wecker                                                                              //
//  _____________________________________________________                               //
//                                                                                      //
//  Copyright © 2016 Reimar Grasbon (softwork@grasbon.de)                               //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  This software is subjected to the FreeBSD License. Redistribution and use in source //
//  and binary forms, with or without modification, are permitted provided that the     //
//  following conditions are met:                                                       //
//                                                                                      //
//  1. Redistributions of source code must retain the above copyright notice, this list //
//     of conditions and the following disclaimer.                                      //
//                                                                                      //
//  2. Redistributions in binary form must reproduce the above copyright notice, this   //
//     list of conditions and the following disclaimer in the documentation and/or      //
//     other materials provided with the distribution.                                  //
//                                                                                      //
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY //
//  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED           //
//  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  //
//  IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,    //
//  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT  //
//  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR  //
//  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,   //
//  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)  //
//  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE          //
//  POSSIBILITY OF SUCH DAMAGE.                                                         //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////

#ifndef __ALARM__
#define __ALARM__

#include "Conf.h"
#include "TypeDefs.h"

//////////////////////////////////////////////////////////////////////////////////////////
//  Typen  ///////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
typedef enum                        // Weckbetriebsarten:
{   AO_DAILY            = 0,        // · Täglich
    AO_DAILY_EX_WEEKEND = 1,        // · Täglich außer an Wochenenden (Sa/So)
    AO_WORKDAY          = 2,        // · Täglich außer an Wochenenden und Feiertagen
    AO_WEEKEND_ONLY     = 3,        // · Nur an Wochenenden
    AO_WEEKEND_HOLIDAY  = 4,        // · Nur an Wochenenden und Feiertagen
    AO_HOLIDAY_ONLY     = 5,        // · Nur an Feiertagen
    AO_ONCE_ONLY        = 6         // · Einmalig (Keine Wiederholung)
} AlarmOperation;

//////////////////////////////////////////////////////////////////////////////////////////
//  Funktionen  //////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
void  ALARM_Enable(bool);
bool  ALARM_IsEnabled(void);
bool  ALARM_IsSet(void);
bool  ALARM_IsAlarm(void);
bool  ALARM_IsSnooze(void);
bool  ALARM_AnnouncementPhase(void);
void  ALARM_Proceed(void);

//////////////////////////////////////////////////////////////////////////////////////////

#endif
