﻿//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  Konfiguration                                                                       //
//  _____________________________________________________                               //
//                                                                                      //
//  Copyright © 2016 Reimar Grasbon (softwork@grasbon.de)                               //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  This software is subjected to the FreeBSD License. Redistribution and use in source //
//  and binary forms, with or without modification, are permitted provided that the     //
//  following conditions are met:                                                       //
//                                                                                      //
//  1. Redistributions of source code must retain the above copyright notice, this list //
//     of conditions and the following disclaimer.                                      //
//                                                                                      //
//  2. Redistributions in binary form must reproduce the above copyright notice, this   //
//     list of conditions and the following disclaimer in the documentation and/or      //
//     other materials provided with the distribution.                                  //
//                                                                                      //
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY //
//  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED           //
//  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  //
//  IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,    //
//  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT  //
//  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR  //
//  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,   //
//  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)  //
//  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE          //
//  POSSIBILITY OF SUCH DAMAGE.                                                         //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////

#ifndef __CONF__
#define __CONF__

///////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Konfiguration  ////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////
#define CFG_EEPROM_CY4_SELF_ADR       2   // EEProm-Speicherort der eigenen Cy4-Adr.:    0 ..    4  [Byte]
#define CFG_EEPROM_STORING_BASE      10   // EEProm-Basisadr. der Datenaufbewahrung:     8 .. 1022  [Byte]
#define CFG_STR_CAPACITY              8   // Kapazität des Stringpuffers:                2 ..  250  [Byte]
#define CFG_PB_DOWN_RESPONSIVITY      1   // Ansprechempfind. Drucktaste drücken:        0 ..  250  [s÷100]
#define CFG_PB_UP_RESPONSIVITY       10   // Ansprechempfind. Drucktaste loslassen:      0 ..  250  [s÷100]
#define CFG_PB_HOLD_EVENT_TIME        4   // Zeit bis Knopf-gedrückt-halten Ereignis:    1 ..   25  [s]
#define CFG_ROT_ENC_TYPE              3   // Drehimpulsgeber-Typ (s. ISR() in Board)     1 ..    3  [#]
#define CFG_ENC_DOWN_RESPONSIVITY     2   // Ansprechempfind. Drehimp.-Taste drücken:    0 ..  250  [s÷100]
#define CFG_ENC_UP_RESPONSIVITY       5   // Ansprechempfind. Drehimp.-Taste loslas.:    0 ..  250  [s÷100]
#define CFG_AMB_BRIGHT_UPDATE       300   // Aktualisierung der Umgebungshelligkeit:    15 .. 9999  [ms]
#define CFG_SYS_CLOCK_SYNC_INTERVAL  50   // Synchronisierungsintervall der Systemuhr:   1 ..  250  [min]
#define CFG_LED_BILLOW_SPEED         15   // Geschwindigkeit des LED-waberns:            1 ..   99  [ms]
#define CFG_DISPLAY_BRIGHT_AGILITY    5   // Agilität der Anzeigen-Helligkeitsanpass. :  1 ..    9  [#]
#define CFG_TIMEZONE                  1   // Lokale Zeitzone als Differenz zur UTC:    -11 ..  +12  [h]
#define CFG_DCF_FAIL_TIME           900   // Signalisierung des DCF Funkzeitausfalls:    4 .. 9000  [min]
#define CFG_MODE_MENU_TIMEOUT        10   // Zeitgrenze für Menümodus:                   3 ..  500  [s]
#define CFG_MODE_SETTINGS_TIMEOUT    15   // Zeitgrenze für Einstellungsmodus:           1 ..   30  [s]
#define CFG_ALARM_ANNOUNCEMENT       15   // Vorankündigung des Weckereignisses:         2 ..   59  [s]
#define CFG_REARM_ALARM_LEAD_TIME    11   // Reaktivierungsvorlauf des Weckers:          2 ..   22  [h]
#define CFG_ENTER_SETTINGS_TIME      40   // Knopf-Druckhaltedauer für Einstell.-Menü:   1 ..  250  [s÷10]

///////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Werksvoreinstellungen  ////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////
#define DEF_DISPLAY_BLANK_START       5   // Zeit, bis zur Abschaltung der Anzeige:       1 ..    99 [min]
#define DEF_MOTION_SENS_DISPLAY       5   // Bewegungsmelder-Empf. bei Anzeige ein:       1 ..     9 [#]
#define DEF_ALARM_ENABLED         false   // true = Wecker gestellt:                    true/false
#define DEF_ALARM_OPERATION    AO_DAILY   // Weckbetriebsart:                           [AlarmOperation]
#define DEF_ALARM_DURATION           20   // Dauer der Weckalarms:                        1 ..   240 [min]
#define DEF_ALARM_TIME        { 07,00 }   // Weckzeit:                                00,00 .. 23,59 [h,m]
#define DEF_ALARM_TYPERADIO       false   // true/false = Weckmittel Radio/Signal:      true/false
#define DEF_SNOOZE_ENABLED         true   // true = Schlummerfunktion aktiv:            true/false
#define DEF_MOTION_SENS_SNOOZE        5   // Bewegungsmelder-Empf. bei Schlummen:         1 ..     9 [#]
#define DEF_SNOOZE_DURATION           5   // Dauer der Schlummerphase:                    1 ..    99 [min]
#define DEF_GERMAN_REGION         GR_NW   // Deutsches Bundesland:                      [GermanRegion]
#define DEF_SHOW_HOLIDAY           true   // Anzeige freier Tage:                         true/false
#define DEF_AUTO_DST_ENABLED       true   // true = Automatische Sommerzeitumschaltung:   true/false

#endif
