﻿//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//    ___          _           _       _____                                            //
//   / _ \   ___  | |_   ___  | |_    |___  |                                           //
//  | | | | / __| | __| / _ \ | __|      / /                                            //
//  | |_| || (__  | |_ |  __/ | |_      / /                                             //
//   \___/  \___|  \__| \___|  \__|    /_/                                              //
//                                                                                      //
//                                                                                      //
//  Version 2017.12                                                                     //
//  _____________________________________________________                               //
//                                                                                      //
//  Copyright © 2017 Reimar Grasbon (softwork@grasbon.de)                               //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  This software is subjected to the FreeBSD License. Redistribution and use in source //
//  and binary forms, with or without modification, are permitted provided that the     //
//  following conditions are met:                                                       //
//                                                                                      //
//  1. Redistributions of source code must retain the above copyright notice, this list //
//     of conditions and the following disclaimer.                                      //
//                                                                                      //
//  2. Redistributions in binary form must reproduce the above copyright notice, this   //
//     list of conditions and the following disclaimer in the documentation and/or      //
//     other materials provided with the distribution.                                  //
//                                                                                      //
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY //
//  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED           //
//  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  //
//  IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,    //
//  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT  //
//  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR  //
//  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,   //
//  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)  //
//  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE          //
//  POSSIBILITY OF SUCH DAMAGE.                                                         //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////

#include "Board.h"
#include "Storing.h"
#include "Display.h"
#include "Application.h"

//////////////////////////////////////////////////////////////////////////////////////////
void
main(void)
{
    BOARD_Startup();
    STORING_Startup();
    DISPLAY_Startup();
    APPLICATION_Startup();
    while( BOARD_DoMainLoop() )
    {   BOARD_Proceed();
        STORING_Proceed();
        DISPLAY_Proceed();
        APPLICATION_Proceed();
    }
    APPLICATION_Shutdown();
    DISPLAY_Shutdown();
    STORING_Shutdown();
    BOARD_Shutdown();
}

//////////////////////////////////////////////////////////////////////////////////////////
